/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryItemHighlightType_$type } from "./CategoryItemHighlightType";
import { MarkerType_$type } from "./MarkerType";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Base, enumGetBox, fromEnum, typeCast, Point_$type, markType, markDep, runOn } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-react-core";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Rect } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { DataContext } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, truncate } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Marker } from "./Marker";
import { BrushUtil } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { DataTemplatePassInfo } from "igniteui-react-core";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
/**
 * @hidden
 */
var CategoryItemHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayer, _super);
    function CategoryItemHighlightLayer() {
        var _this = _super.call(this) || this;
        _this.w8 = false;
        _this.w7 = true;
        _this.xb = 10;
        var a = new CategoryItemHighlightLayerFrame();
        var b = new CategoryItemHighlightLayerFrame();
        var c = new CategoryItemHighlightLayerFrame();
        _this.uh = a;
        _this.ug = b;
        _this.ui = c;
        _this.ab = CategoryItemHighlightLayer.$;
        return _this;
    }
    CategoryItemHighlightLayer.prototype.bc = function () {
        return new CategoryItemHighlightLayer();
    };
    CategoryItemHighlightLayer.prototype.get_d6 = function () {
        return true;
    };
    CategoryItemHighlightLayer.prototype.cd = function () {
        return new CategoryItemHighlightLayerView(this);
    };
    CategoryItemHighlightLayer.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.w2 = a;
    };
    CategoryItemHighlightLayer.prototype.vu = function (a, b) {
        if (this.w6 == null || this.w6 == a) {
            if (!this.at.c) {
                this.pr(b);
            }
        }
    };
    CategoryItemHighlightLayer.prototype.un = function (a) {
        if (!_super.prototype.un.call(this, a)) {
            return false;
        }
        if (this.xk != null) {
            if (a.eq) {
                var b = a.lv();
                if (!Base.equalsStatic(this.xk, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.xk, a.name)) {
                    return false;
                }
            }
        }
        var c = this.vp(a);
        if (!c.c) {
            return false;
        }
        return true;
    };
    CategoryItemHighlightLayer.prototype.vw = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.vw.call(this, a, b);
        var c = a;
        var d = this.xa;
        c.g.clear();
        if (isNaN_(this.wz.x) && isNaN_(this.wz.y)) {
            return;
        }
        if (this.un(this.w6)) {
            this.xq(this.w6, c, d);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.cv.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (this.un(e)) {
                        this.xq(e, c, d);
                    }
                    if (e.isStacked) {
                        e.n6(function (f) {
                            if (_this.un(f)) {
                                _this.xq(f, c, d);
                            }
                            if (f.dw) {
                                f.n4(function (g) {
                                    if (_this.un(g)) {
                                        _this.xq(g, c, d);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (e.dw) {
                        e.n4(function (f) {
                            if (_this.un(f)) {
                                _this.xq(f, c, d);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CategoryItemHighlightLayer.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case CategoryItemHighlightLayer.$$p[4]:
            case CategoryItemHighlightLayer.$$p[5]:
            case CategoryItemHighlightLayer.$$p[2]:
            case CategoryItemHighlightLayer.$$p[3]:
                this.pr(true);
                break;
            case CategoryItemHighlightLayer.$$p[7]:
            case CategoryItemHighlightLayer.$$p[8]:
                this.pr(true);
                break;
            case CategoryItemHighlightLayer.$$p[9]:
                this.w8 = d;
                this.pr(true);
                break;
            case CategoryItemHighlightLayer.$$p[1]:
                this.pr(true);
                break;
            case CategoryItemHighlightLayer.$$p[0]:
                this.xb = this.xc;
                this.pr(true);
                break;
            case CategoryItemHighlightLayer.$$p[6]:
                this.w7 = d;
                this.pr(true);
                break;
        }
    };
    CategoryItemHighlightLayer.prototype.xq = function (a, b, c) {
        if (this.cg == null || this.cg.by.isEmpty || this.cg.bx.isEmpty) {
            return;
        }
        if (!a.ed && !a.el) {
            return;
        }
        var d = a;
        if (d.categoryAxis == null) {
            return;
        }
        var e = this.wz.x;
        e = this.cg.bx.left + this.cg.bx.width * (e - this.cg.by.left) / this.cg.by.width;
        var f = this.wz.y;
        f = this.cg.bx.top + this.cg.bx.height * (f - this.cg.by.top) / this.cg.by.height;
        var g = this.w9;
        var h = true;
        var i = typeCast(IHasCategoryModePreference_$type, a);
        var j = 0;
        if (i != null) {
            j = i.preferredCategoryMode(d.categoryAxis);
            if (j == 2) {
                h = false;
            }
        }
        var k = true;
        if (!h || this.w3 == 2) {
            k = false;
        }
        if (this.w3 == 1) {
            k = true;
        }
        var l = this.vp(a);
        if (!l.c) {
            return;
        }
        if (k) {
            var m = a.tj(l.d, this.xa, g);
            if (j != 0 && !d.categoryAxis.cn) {
                var n = m.x;
                if (a.el) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
                else if (a.ed) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
            }
            if (!isNaN_(m.x) && !isNaN_(m.y)) {
                m = this.to(m);
            }
            this.xo(m, b, a);
        }
        else {
            var o = a.tj(l.d, this.xa, g);
            var p = void 0;
            var q = this.getEffectiveViewport1(this.cg);
            if (a.isVertical) {
                var r = o.y;
                var s = d.categoryAxis;
                var t = this.xb;
                if (j != 0) {
                    t = s.k4(this.cg.by, this.cg.bx, q);
                }
                if (isNaN_(t) || isInfinity(t)) {
                    return;
                }
                p = new Rect(0, this.ty.left, r - t / 2, this.ty.width, t);
            }
            else {
                var u = o.x;
                var v = d.categoryAxis;
                var w = this.xb;
                if (j != 0) {
                    w = v.k4(this.cg.by, this.cg.bx, q);
                }
                if (isNaN_(w) || isInfinity(w)) {
                    return;
                }
                p = new Rect(0, u - w / 2, this.ty.top, w, this.ty.height);
            }
            p.intersect(this.cg.bx);
            this.xp(p, b, a);
        }
    };
    CategoryItemHighlightLayer.prototype.xo = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.x;
        d.e = a.y;
        d.i = this.wp();
        if (this.x4 != null) {
            d.i = this.x4;
        }
        d.j = this.wq();
        if (this.x5 != null) {
            d.j = this.x5;
        }
        if (d.i == null) {
            if (c.hasMarkers) {
                d.i = this.w2.cl(c.s1());
            }
            else {
                d.i = this.w2.cl(c.su);
            }
        }
        if (d.j == null) {
            if (c.hasMarkers) {
                d.j = this.w2.cl(c.s2());
            }
            else {
                d.j = this.w2.cl(c.sx);
            }
        }
        d.d = this.hl;
        d.f = Base.getHashCodeStatic(c);
        d.g = this.w4(c, a);
        var e = (typeCast(MarkerSeries.$, c) !== null) ? c.uw : null;
        if (e == null || e == MarkerSeries.uz || (this.w5 != 2 && this.w5 != 0)) {
            var f = MarkerSeries.ud(c, 2);
            if (this.w5 != 2 && this.w5 != 0) {
                f = this.w5;
            }
            switch (f) {
                case 3:
                case 13:
                    e = this.cv.p2;
                    break;
                case 4:
                    e = this.cv.qb;
                    break;
                case 5:
                    e = this.cv.p8;
                    break;
                case 6:
                    e = this.cv.p9;
                    break;
                case 7:
                    e = this.cv.p3;
                    break;
                case 8:
                    e = this.cv.p6;
                    break;
                case 9:
                    e = this.cv.p4;
                    break;
                case 10:
                    e = this.cv.qa;
                    break;
                case 11:
                    e = this.cv.p7;
                    break;
                case 12:
                    e = this.cv.p5;
                    break;
            }
        }
        d.h = this.xt != null ? this.xt : e;
        if (!isNaN_(d.b) && !isNaN_(d.e)) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.w4 = function (a, b) {
        var c = a.js(b);
        var d = a.hw(b);
        if (this.xa && d != Math.floor(d)) {
            c = null;
        }
        return ((function () {
            var $ret = new DataContext();
            $ret.series = a;
            $ret.item = c;
            return $ret;
        })());
    };
    CategoryItemHighlightLayer.prototype.xp = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.i = this.wp();
        d.j = this.wq();
        if (d.i == null) {
            if (c != null) {
                d.i = this.w2.cm(c.su);
            }
        }
        if (d.j == null) {
            if (c != null) {
                d.j = this.w2.cm(c.sx);
            }
        }
        d.d = this.hl;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.vz = function (a, b) {
        var e_2, _a;
        _super.prototype.vz.call(this, a, b);
        var c = this.w2.b9;
        var d = this.w2.b8;
        var e = 0;
        var f = 0;
        var g = a;
        try {
            for (var _b = __values(fromEnum(g.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                if (h.h != null) {
                    var i = d.item(f);
                    this.xr(h, i);
                    f++;
                }
                else {
                    var j = c.item(e);
                    this.xs(h, j);
                    e++;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.count = e;
        d.count = f;
    };
    CategoryItemHighlightLayer.prototype.xr = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
            b._visibility = 1;
            return;
        }
        var c = { $type: Point_$type, x: a.b, y: a.e };
        var d = a.g;
        d.itemBrush = a.i;
        var e = d.series.tj(c, this.dk() || this.w8, this.w7);
        if (isNaN_(e.x) || isNaN_(e.y)) {
            b._visibility = 1;
            return;
        }
        this.w2.cf(b, e.x, e.y);
        b.ah = a.h;
        b.content = a.g;
    };
    CategoryItemHighlightLayer.prototype.xs = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.w2.cg(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.i;
        b._stroke = a.j;
        b.ad = a.d;
        if (this.s9 != null) {
            b.ai = this.s9;
        }
        else {
            b.ai = null;
        }
        b.aj = this.ta;
        b.am = this.tc;
        b.al = this.tb;
        b.ak = this.tb;
        b.ac = this.im;
    };
    CategoryItemHighlightLayer.prototype.fn = function () {
        return true;
    };
    CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
    CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:xc:xu', [1, 10], 'HighlightType:w3:xv', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:x4:xw', [Brush.$, null], 'MarkerOutline:x5:xx', [Brush.$, null], 'MarkerTemplate:xt:xy', [DataTemplate.$, null], 'MarkerType:w5:xz', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:w9:x0', [0, true], 'TargetSeriesName:xk:x1', [2, null], 'TargetSeries:w6:x2', [Series.$, null], 'UseInterpolation:xa:x3', [0, false]]);
    return CategoryItemHighlightLayer;
}(AnnotationLayer));
export { CategoryItemHighlightLayer };
/**
 * @hidden
 */
var CategoryItemHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayerView, _super);
    function CategoryItemHighlightLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b9 = null;
        _this.b8 = null;
        _this.ca = null;
        _this.cb = null;
        _this.b7 = a;
        _this.ca = new List$1(ContentControl.$, 0);
        _this.cb = new List$1(Rectangle.$, 0);
        return _this;
    }
    CategoryItemHighlightLayerView.prototype.au = function () {
        var _this = this;
        _super.prototype.au.call(this);
        this.b9 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.cn);
            $ret.activate = runOn(_this, _this.ch);
            $ret.disactivate = runOn(_this, _this.cj);
            $ret.destroy = runOn(_this, _this.ci);
            return $ret;
        })());
        this.b8 = ((function () {
            var $ret = new Pool$1(ContentControl.$);
            $ret.create = runOn(_this, _this.ck);
            $ret.activate = runOn(_this, _this.cc);
            $ret.disactivate = runOn(_this, _this.ce);
            $ret.destroy = runOn(_this, _this.cd);
            return $ret;
        })());
    };
    CategoryItemHighlightLayerView.prototype.cn = function () {
        var a = new Rectangle();
        a.ab = false;
        this.cb.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.ch = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.cj = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.ci = function (a) {
        this.cb.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.ck = function () {
        var a = new Marker();
        this.ca.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.cc = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.ce = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.cd = function (a) {
        this.ca.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.cl = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, 0.3);
    };
    CategoryItemHighlightLayerView.prototype.cm = function (a) {
        if (a != null) {
            var b = BrushUtil.m(a, 0.3);
            if (b.isGradient) {
                var c = b;
                if (c.gradientStops != null) {
                    for (var d = 0; d < c.gradientStops.length; d++) {
                        var e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    };
    CategoryItemHighlightLayerView.prototype.cg = function (a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    };
    CategoryItemHighlightLayerView.prototype.cf = function (a, b, c) {
        a.n = b;
        a.o = c;
    };
    CategoryItemHighlightLayerView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        var c = a;
        var d = c.content;
        if (d != null) {
            if (d.itemBrush != null) {
                d.actualItemBrush = d.itemBrush;
            }
            var e = d.series;
            if (e.hasMarkers) {
                d.outline = e.s2();
            }
            d.thickness = e.ht();
        }
    };
    CategoryItemHighlightLayerView.prototype.a8 = function (a, b) {
        var e_3, _a;
        _super.prototype.a8.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.cb.count; c++) {
                var d = this.cb._inner[c];
                if (d._visibility == 0) {
                    a.w(d);
                }
            }
            if (this.ca.count > 0) {
                var e = new DataTemplatePassInfo();
                e.isHitTestRender = b;
                e.context = a.h();
                e.viewportTop = this.bx.top;
                e.viewportLeft = this.bx.left;
                e.viewportWidth = this.bx.width;
                e.viewportHeight = this.bx.height;
                e.passID = "ItemMarkers";
                var f = new DataTemplateRenderInfo();
                f.isHitTestRender = b;
                f.passInfo = e;
                var g = new DataTemplateMeasureInfo();
                g.passInfo = e;
                var h = false;
                var i = a.h();
                g.context = i;
                f.context = i;
                g.renderContext = a;
                f.renderContext = a;
                var j = 0;
                var k = 0;
                var l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                for (var m = 0; m < this.ca.count; m++) {
                    var n = this.ca._inner[m];
                    if (n == null || n.ah == null) {
                        continue;
                    }
                    var o = n.ah;
                    if (!l.containsKey(o)) {
                        l.addItem(o, o);
                        if (o != null && o.passStarting != null) {
                            o.passStarting(e);
                        }
                    }
                    if (n._visibility == 1) {
                        continue;
                    }
                    this.bi(n, m, b);
                    if (!h) {
                        g.data = n.content;
                        g.width = n.width;
                        g.height = n.height;
                        if (o.measure != null) {
                            g.data = n.content;
                            o.measure(g);
                            h = g.isConstant;
                            if (h) {
                                j = g.width;
                                k = g.height;
                            }
                        }
                        f.availableWidth = g.width;
                        f.availableHeight = g.height;
                    }
                    else {
                        f.availableWidth = j;
                        f.availableHeight = k;
                    }
                    if (!isNaN_(n.width) && !isInfinity(n.width)) {
                        f.availableWidth = n.width;
                    }
                    if (!isNaN_(n.height) && !isInfinity(n.height)) {
                        f.availableHeight = n.height;
                    }
                    a.q(f, n);
                    n.m = f.availableWidth;
                    n.l = f.availableHeight;
                }
                try {
                    for (var _b = __values(fromEnum(l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var p = _c.value;
                        if (p != null && p.passCompleted != null) {
                            p.passCompleted(e);
                        }
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
        }
    };
    CategoryItemHighlightLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        for (var b = 0; b < this.cb.count; b++) {
            this.e.a5.exportRectangleData(a, this.cb._inner[b], "catItemRect", ["Main", "CategoryItem"]);
        }
        for (var c = 0; c < this.ca.count; c++) {
            this.e.a5.exportMarkerVisualDataFromMarker(this.e, a, this.ca._inner[c]);
        }
    };
    CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
    return CategoryItemHighlightLayerView;
}(AnnotationLayerView));
export { CategoryItemHighlightLayerView };
